﻿IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_FMM_ECOBOM')
CREATE TABLE T_FMM_ECOBOM
(
  FID            BIGINT DEFAULT 0 NOT NULL,
  FNUMBER        NVARCHAR(30) DEFAULT ' ' NOT NULL,
  FSTATUS        NVARCHAR(30) DEFAULT ' ' NOT NULL,
  FCREATORID     BIGINT DEFAULT 0 NOT NULL,
  FMODIFIERID    BIGINT DEFAULT 0 NOT NULL,
  FENABLE        NVARCHAR(30) DEFAULT ' ' NOT NULL,   
  FCREATETIME    DATETIME,
  FMODIFYTIME    DATETIME,
  FMASTERID      BIGINT DEFAULT 0 NOT NULL,
  FGROUPID       BIGINT DEFAULT 0 NOT NULL,
  FORGID         BIGINT DEFAULT 0 NOT NULL,
  FCREATEORGID   BIGINT DEFAULT 0 NOT NULL,
  FCTRLSTRATEGY  NVARCHAR(30) DEFAULT ' ' NOT NULL,
  FMATERIALID    BIGINT DEFAULT 0 NOT NULL,
  FVERSIONID     BIGINT DEFAULT 0 NOT NULL,
  FREPLACENOID   BIGINT DEFAULT 0 NOT NULL,
  FYIELDRATE     BIGINT DEFAULT 0 NOT NULL,
  FAUXPROPERTYID BIGINT DEFAULT 0 NOT NULL,
  FISCOPRODUCT   CHAR(1) DEFAULT '0' NOT NULL,
  FTYPEID        BIGINT DEFAULT 0 NOT NULL,
  FAUDITORID     BIGINT DEFAULT 0 NOT NULL,
  FAUDITDATE     DATETIME,
  FDISABLEUSERID BIGINT DEFAULT 0 NOT NULL,
  FDISABLEDATE   DATETIME,
  FENABLEUSERID  BIGINT DEFAULT 0 NOT NULL,
  FENABLEDATE    DATETIME,
  FECNVERSION    NVARCHAR(50) DEFAULT ' ' NOT NULL,
  FECN           BIGINT DEFAULT 0 NOT NULL,
  FQTYBASEUNIT   BIGINT DEFAULT 0 NOT NULL,
  FMATERIAL      BIGINT DEFAULT 0 NOT NULL,
  FGROUPFIELD    BIGINT DEFAULT 0 NOT NULL,
  FMATID         BIGINT DEFAULT 0 NOT NULL,
  FECOBOMID      NVARCHAR(50) DEFAULT ' ' NOT NULL,
  FBOMID         NVARCHAR(50) DEFAULT ' ' NOT NULL,
  FEBOMID        NVARCHAR(50) DEFAULT ' ' NOT NULL,
  FMACHINETYPE   BIGINT DEFAULT 0 NOT NULL,
  FMACHINE       BIGINT DEFAULT 0 NOT NULL,
  FUSERGROUP     BIGINT DEFAULT 0 NOT NULL,
  FVALIDDATE     DATETIME
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_FMM_ECOBOM_L')
CREATE TABLE T_FMM_ECOBOM_L
(
  FPKID        NVARCHAR(18) DEFAULT ' ' NOT NULL,
  FID          BIGINT DEFAULT 0 NOT NULL,
  FLOCALEID    NVARCHAR(10) DEFAULT ' ' NOT NULL,
  FNAME        NVARCHAR(50) DEFAULT ' ' NOT NULL,
  FDESCRIPTION NVARCHAR(255) DEFAULT ' ' NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_FMM_ECOBOMCOPENTRY')
CREATE TABLE T_FMM_ECOBOMCOPENTRY
(
  FID            BIGINT DEFAULT 0 NOT NULL,
  FENTRYID       BIGINT DEFAULT 0 NOT NULL,
  FSEQ           BIGINT DEFAULT 0 NOT NULL,
  FTYPE          NVARCHAR(30) DEFAULT ' ' NOT NULL,
  FMATERIALID    BIGINT DEFAULT 0 NOT NULL,
  FUNITID        BIGINT DEFAULT 0 NOT NULL,
  FQTY           DECIMAL(23,10) DEFAULT 0 NOT NULL,
  FOPERATIONID   BIGINT DEFAULT 0 NOT NULL,
  FVALIDDATE     DATETIME,
  FINVALIDDATE   DATETIME,
  FVERSIONID     BIGINT DEFAULT 0 NOT NULL,
  FAUXPROPERTYID BIGINT DEFAULT 0 NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_FMM_ECOBOMCOPENTRY_L')
CREATE TABLE T_FMM_ECOBOMCOPENTRY_L
(
  FPKID     NVARCHAR(18) DEFAULT ' ' NOT NULL,
  FENTRYID  BIGINT DEFAULT 0 NOT NULL,
  FLOCALEID NVARCHAR(10) DEFAULT ' ' NOT NULL,
  FREMARK   NVARCHAR(255) DEFAULT ' ' NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_FMM_ECOBOMENTRY')
CREATE TABLE T_FMM_ECOBOMENTRY
(
  FID              BIGINT DEFAULT 0 NOT NULL,
  FENTRYID         BIGINT DEFAULT 0 NOT NULL,
  FSEQ             BIGINT DEFAULT 0 NOT NULL,
  FTYPE            NVARCHAR(30) DEFAULT ' ' NOT NULL,
  FMATERIALID      BIGINT DEFAULT 0 NOT NULL,
  FQTY             DECIMAL(23,10) DEFAULT 0 NOT NULL,
  FUNITID          BIGINT DEFAULT 0 NOT NULL,
  FVERSIONID       BIGINT DEFAULT 0 NOT NULL,
  FQTYTYPE         NVARCHAR(30) DEFAULT ' ' NOT NULL,
  FQTYNUMERATOR    DECIMAL(23,10) DEFAULT 0 NOT NULL,
  FQTYDENOMINATOR  DECIMAL(23,10) DEFAULT 0 NOT NULL,
  FFIXSCRAP        DECIMAL(23,10) DEFAULT 0 NOT NULL,
  FSCRAPRATE       DECIMAL(23,10) DEFAULT 0 NOT NULL,
  FVALIDDATE       DATETIME,
  FINVALIDDATE     DATETIME,
  FAUXPROPERTYID   BIGINT DEFAULT 0 NOT NULL,
  FISREPLACEPLANMM CHAR(1) DEFAULT '0' NOT NULL,
  FECNNO           NVARCHAR(50) DEFAULT ' ' NOT NULL,
  FMATERIALATTR    NVARCHAR(30) DEFAULT ' ' NOT NULL,
  FISJUMPLEVEL     CHAR(1) DEFAULT '0' NOT NULL,
  FOWNERTYPE       NVARCHAR(30) DEFAULT ' ' NOT NULL,
  FOWNERID         BIGINT DEFAULT 0 NOT NULL,
  FISSUEMODE       NVARCHAR(30) DEFAULT ' ' NOT NULL,
  FISKEY           CHAR(1) DEFAULT '0' NOT NULL,
  FISSTOCKALLOC    CHAR(1) DEFAULT '0' NOT NULL,
  FOUTORGID        BIGINT DEFAULT 0 NOT NULL,
  FOUTWAREHOUSEID  BIGINT DEFAULT 0 NOT NULL,
  FREPLACEPLANID   BIGINT DEFAULT 0 NOT NULL,
  FLEADTIME        BIGINT DEFAULT 0 NOT NULL,
  FTIMEUNIT        NVARCHAR(30) DEFAULT ' ' NOT NULL,
  FSUPPLYTYPE      NVARCHAR(30) DEFAULT ' ' NOT NULL,
  FSUPPLYORGID     BIGINT DEFAULT 0 NOT NULL,
  FSUPPLYMODE      NVARCHAR(30) DEFAULT ' ' NOT NULL,
  FWAREHOUSEID     BIGINT DEFAULT 0 NOT NULL,
  FLOCATIONID      BIGINT DEFAULT 0 NOT NULL,
  FISREPLACE       CHAR(1) DEFAULT '0' NOT NULL,
  FOPERATIONNUMBER NVARCHAR(50) DEFAULT ' ' NOT NULL,
  FPROCESSSEQ      NVARCHAR(50) DEFAULT ' ' NOT NULL,
  FECNVERION       NVARCHAR(50) DEFAULT ' ' NOT NULL,
  FECNVALIDDATE    DATETIME,
  FENTRYECN        BIGINT DEFAULT 0 NOT NULL,
  FISBULKMATERIAL  CHAR(1) DEFAULT '0' NOT NULL,
  FISBACKFLUSHNEW  NVARCHAR(30) DEFAULT ' ' NOT NULL,
  FNUMBER          NVARCHAR(50) DEFAULT ' ' NOT NULL,
  FBOMENTRYID      BIGINT DEFAULT 0 NOT NULL,
  FENTRYMODE       NVARCHAR(30) DEFAULT ' ' NOT NULL,
  FENTRYECNID      NVARCHAR(50) DEFAULT ' ' NOT NULL,
  FENTRYMATERIALID BIGINT DEFAULT 0 NOT NULL,
  FENTRYMATID      BIGINT DEFAULT 0 NOT NULL,
  FBOMID           BIGINT DEFAULT 0 NOT NULL,
  FOUTLOCATIONID   BIGINT DEFAULT 0 NOT NULL
);


IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_FMM_ECOBOMENTRY_L')
CREATE TABLE T_FMM_ECOBOMENTRY_L
(
  FPKID     NVARCHAR(18) DEFAULT ' ' NOT NULL,
  FENTRYID  BIGINT DEFAULT 0 NOT NULL,
  FLOCALEID NVARCHAR(10) DEFAULT ' ' NOT NULL,
  FREMARK   NVARCHAR(255) DEFAULT ' ' NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_FMM_ECOBOMQTYENTRY')
CREATE TABLE T_FMM_ECOBOMQTYENTRY
(
  FENTRYID        BIGINT DEFAULT 0 NOT NULL,
  FDETAILID       BIGINT DEFAULT 0 NOT NULL,
  FSEQ            BIGINT DEFAULT 0 NOT NULL,
  FBATCHSTARTQTY  DECIMAL(23,10) DEFAULT 0 NOT NULL,
  FBATCHENDQTY    DECIMAL(23,10) DEFAULT 0 NOT NULL,
  FISSTEPFIX      CHAR(1) DEFAULT '0' NOT NULL,
  FQTYNUMERATOR   DECIMAL(23,10) DEFAULT 0 NOT NULL,
  FQTYDENOMINATOR DECIMAL(23,10) DEFAULT 0 NOT NULL,
  FFIXSCRAP       DECIMAL(23,10) DEFAULT 0 NOT NULL,
  FSCRAPRATE      DECIMAL(23,10) DEFAULT 0 NOT NULL,
  FSRCID          BIGINT DEFAULT 0 NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_FMM_ECOBOMSETUPENTRY')
CREATE TABLE T_FMM_ECOBOMSETUPENTRY
(
  FENTRYID  BIGINT DEFAULT 0 NOT NULL,
  FDETAILID BIGINT DEFAULT 0 NOT NULL,
  FSEQ      BIGINT DEFAULT 0 NOT NULL,
  FQTY      DECIMAL(23,10) DEFAULT 0 NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_FMM_ECOBOMSETUPENTRY_L')
CREATE TABLE T_FMM_ECOBOMSETUPENTRY_L
(
  FPKID          NVARCHAR(18) DEFAULT ' ' NOT NULL,
  FDETAILID      BIGINT DEFAULT 0 NOT NULL,
  FLOCALEID      NVARCHAR(10) DEFAULT ' ' NOT NULL,
  FSETUPLOCATION NVARCHAR(50) DEFAULT ' ' NOT NULL,
  FREMARK        NVARCHAR(100) DEFAULT ' ' NOT NULL
);







