-- 排产计划方案定义_实体表_ T_MPS_PROPSDEF ----
IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_PROPSDEF')
CREATE TABLE T_MPS_PROPSDEF (
	FID 					BIGINT 					NOT NULL DEFAULT 0,
	FNUMBER 				NVARCHAR(30) 			NOT NULL DEFAULT ''' ''',
	FNAME 					NVARCHAR(50) 			NOT NULL DEFAULT ''' ''',
	FSTATUS 				VARCHAR(50) 			NOT NULL DEFAULT ''' ''',
	FCREATORID 				BIGINT 					NOT NULL DEFAULT 0,
	FMODIFIERID 			BIGINT 					NOT NULL DEFAULT 0,
	FENABLE 				VARCHAR(50) 			NOT NULL DEFAULT ''' ''',
	FCREATETIME 			DATETIME 				NULL,
	FMODIFYTIME 			DATETIME 				NULL,
	FMASTERID 				BIGINT 					NOT NULL DEFAULT 0,
	FCREATEORGID 			BIGINT 					NOT NULL DEFAULT 0,
	FORGID 					BIGINT 					NOT NULL DEFAULT 0,
	FCTRLSTRATEGY 			NVARCHAR(50) 			NOT NULL DEFAULT ''' ''',
	FSOURCEDATAID 			BIGINT 					NOT NULL DEFAULT 0,
	FBITINDEX 				BIGINT 					NOT NULL DEFAULT 0,
	FSOURCEBITINDEX 		BIGINT 					NOT NULL DEFAULT 0,
	FISDEFAULTSCHE 			CHAR(1) 				NOT NULL DEFAULT '0',
	FPLANOUTLOOK 			BIGINT 					NOT NULL DEFAULT 0,
	FAUDITORID 				BIGINT 					NOT NULL DEFAULT 0,
	FAUDITORTIME 			DATETIME 				NULL,
    FWORKSHIFT              BIGINT                  NOT NULL DEFAULT 0,
    FISPROUCE               CHAR(1)                 NOT NULL DEFAULT '0',
    FISSPLIT                CHAR(1)                 NOT NULL DEFAULT '0',
	FORDERMOD 				BIGINT 					NOT NULL DEFAULT 0,
	FPRIORITYDEFINE 		BIGINT 					NOT NULL DEFAULT 0,
	FCAPMOD 				BIGINT 					NOT NULL DEFAULT 0,
	FMATCHITEM 				BIGINT 					NOT NULL DEFAULT 0,
    FMATCHPRIORITYDEFINE    BIGINT 					NOT NULL DEFAULT 0,
    FDATAMODEL              BIGINT 					NOT NULL DEFAULT 0,
	FCAPSTRA 				NVARCHAR(50) 			NOT NULL DEFAULT ''' ''',
	FCAPCITYCONS 			NVARCHAR(50) 			NOT NULL DEFAULT ''' ''',
	FSCHEDURULE 			BIGINT 					NOT NULL DEFAULT 0,
	FCAPDIS 				NVARCHAR(50) 			NOT NULL DEFAULT ''' ''',

	CONSTRAINT PK_MPS_PROPSDEF PRIMARY KEY(FID)
);
IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_T_MPS_PROPSDEF_CREATEORG') CREATE INDEX IDX_T_MPS_PROPSDEF_CREATEORG ON T_MPS_PROPSDEF(FCREATEORGID);
IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_T_MPS_PROPSDEF_MASTER') CREATE INDEX IDX_T_MPS_PROPSDEF_MASTER ON T_MPS_PROPSDEF(FMASTERID);
IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'T_MPS_PROPSDEF_FNUMBER_IDX') CREATE INDEX T_MPS_PROPSDEF_FNUMBER_IDX ON T_MPS_PROPSDEF(FNUMBER);

-- 排产计划方案定义_多语言表_ T_MPS_PROPSDEF_L ----
IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_PROPSDEF_L')
CREATE TABLE T_MPS_PROPSDEF_L (
	FPKID 				VARCHAR(36) 			NOT NULL DEFAULT ''' ''',
	FID 				BIGINT 					NOT NULL DEFAULT 0,
	FLOCALEID 			VARCHAR(10) 			NOT NULL DEFAULT ' ',
	FNAME 				NVARCHAR(50) 			NOT NULL DEFAULT ''' ''',
	CONSTRAINT PK_MPS_PROPSDEF_L PRIMARY KEY(FPKID)
);
IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_MPS_PROPSDEF_L_0')CREATE INDEX IDX_MPS_PROPSDEF_L_0 ON T_MPS_PROPSDEF_L(FID, FLOCALEID);

-- 排产计划方案定义_组织参数单据体表_ T_MPS_ORGENTRY ----
IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_ORGENTRY')
CREATE TABLE T_MPS_ORGENTRY (
	FID 			BIGINT 			NOT NULL DEFAULT 0,
	FENTRYID 		BIGINT 			NOT NULL DEFAULT 0,
	FSEQ 			INT 			NOT NULL DEFAULT 0,
	FORGNUMBER 		BIGINT 			NOT NULL DEFAULT 0,
	CONSTRAINT PK_MPS_ORGENTRY PRIMARY KEY (FENTRYID)
);
IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_MPS_ORGENTRY_FK') CREATE INDEX IDX_MPS_ORGENTRY_FK ON T_MPS_ORGENTRY(FID);

-- 排产计划方案定义_计算订单单据体表_ T_MPS_ORDERENTRY ----
IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_ORDERENTRY')
CREATE TABLE T_MPS_ORDERENTRY (
	FID 				BIGINT 			NOT NULL DEFAULT 0,
	FENTRYID 			BIGINT 			NOT NULL DEFAULT 0,
	FSEQ 				INT 			NOT NULL DEFAULT 0,
	FISINCALCULATE 		CHAR(1) 		NOT NULL DEFAULT '0',
	FRESOURCECONFIG 	BIGINT 			NOT NULL DEFAULT 0,
	FENTITYOBJECT 		VARCHAR(36) 	NOT NULL DEFAULT ''' ''',
	CONSTRAINT PK_MPS_ORDERENTRY PRIMARY KEY (FENTRYID)
);
IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_MPS_ORDERENTRY_FK') CREATE INDEX IDX_MPS_ORDERENTRY_FK ON T_MPS_ORDERENTRY(FID);


-- 排产计划方案定义_已分配数据模型单据体表_ t_mps_matedataentryentity ----
IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_MATEDATAENTRYENTITY')
CREATE TABLE T_MPS_MATEDATAENTRYENTITY (
  FID 				BIGINT 			NOT NULL DEFAULT 0,
  FENTRYID 			BIGINT 			NOT NULL DEFAULT 0,
  FSEQ 				INT 			NOT NULL DEFAULT 0,
  FISINCALCULATE 		CHAR(1) 		NOT NULL DEFAULT '0',
  FRESOURCECONFIG 	BIGINT 			NOT NULL DEFAULT 0,
  FENTITYOBJECT 		VARCHAR(36) 	NOT NULL DEFAULT ''' ''',
  CONSTRAINT PK_MPS_MATEDATAENTRYENTITY PRIMARY KEY (FENTRYID)
);
IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_MPS_MATEDATAENTRYENTITY_FK') CREATE INDEX IDX_MPS_MATEDATAENTRYENTITY_FK ON T_MPS_MATEDATAENTRYENTITY(FID);