IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_MPS_PROPSDEF' AND KSQL_COL_NAME ='FCALENDARID') 
 ALTER TABLE T_MPS_PROPSDEF ADD (FCALENDARID BIGINT DEFAULT 0 NOT NULL);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_PROPLANWORKENTRY')
 CREATE TABLE T_MPS_PROPLANWORKENTRY (
	FID BIGINT DEFAULT 0 NOT NULL,
	FENTRYID BIGINT DEFAULT 0 NOT NULL,
	FSEQ INT DEFAULT 0 NOT NULL,
	FWORKCENTERID BIGINT DEFAULT 0 NOT NULL,
	FPRODUCTIONRULESID BIGINT DEFAULT 0 NOT NULL,
	FPROCHANGERULESID BIGINT DEFAULT 0 NOT NULL,
    FWORKSHIFTS BIGINT DEFAULT 0 NOT NULL,
	FINTGROUPID BIGINT DEFAULT 0 NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_CAPACITYDEF')
 CREATE TABLE T_MPS_CAPACITYDEF (
	FID BIGINT DEFAULT 0 NOT NULL,
	FNUMBER VARCHAR(30) DEFAULT ' ' NOT NULL,
	FNAME VARCHAR(50) DEFAULT ' ' NOT NULL,
	FSTATUS VARCHAR(50) DEFAULT ' ' NOT NULL,
	FCREATORID BIGINT DEFAULT 0 NOT NULL,
	FMODIFIERID BIGINT DEFAULT 0 NOT NULL,
	FENABLE VARCHAR(50) DEFAULT ' ' NOT NULL,
	FCREATETIME DATETIME,
	FMODIFYTIME DATETIME,
	FMASTERID BIGINT DEFAULT 0 NOT NULL,
	FCREATEORGID BIGINT DEFAULT 0 NOT NULL,
	FORGID BIGINT DEFAULT 0 NOT NULL,
	FCTRLSTRATEGY VARCHAR(50) DEFAULT ' ' NOT NULL,
	FSOURCEDATAID BIGINT DEFAULT 0 NOT NULL,
	FBITINDEX BIGINT DEFAULT 0 NOT NULL,
	FSOURCEBITINDEX BIGINT DEFAULT 0 NOT NULL,
	FWORKCENTERID BIGINT DEFAULT 0 NOT NULL,
	FCAPACITYTYPE VARCHAR(50) DEFAULT ' ' NOT NULL,
	FCYCLESTRATEGY VARCHAR(50) DEFAULT ' ' NOT NULL,
	FCYCLEUNIT VARCHAR(50) DEFAULT ' ' NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_CAPACITYDEF_L')
CREATE TABLE T_MPS_CAPACITYDEF_L (
	FPKID VARCHAR(36) DEFAULT ' ' NOT NULL,
	FID BIGINT DEFAULT 0 NOT NULL,
	FLOCALEID VARCHAR(10) DEFAULT ' ' NOT NULL,
	FNAME VARCHAR(50) DEFAULT ' ' NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_CAPACITYDEFENTRY')
CREATE TABLE T_MPS_CAPACITYDEFENTRY (
	FID BIGINT DEFAULT 0 NOT NULL,
	FENTRYID BIGINT DEFAULT 0 NOT NULL,
	FSEQ INT DEFAULT 0 NOT NULL,
	FMINCAPACITY BIGINT DEFAULT 0 NOT NULL,
	FMAXCAPACITY BIGINT DEFAULT 0 NOT NULL,
	FSTARTDATE DATETIME,
	FENDDATE DATETIME,
	FDESCRIPTION VARCHAR(255) DEFAULT ' ' NOT NULL,
	FGROUPID BIGINT DEFAULT 0 NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_INTENSIVE')
CREATE TABLE T_MPS_INTENSIVE (
	FID BIGINT DEFAULT 0 NOT NULL,
	FNUMBER VARCHAR(30) DEFAULT ' ' NOT NULL,
	FNAME VARCHAR(50) DEFAULT ' ' NOT NULL,
	FSTATUS VARCHAR(50) DEFAULT ' ' NOT NULL,
	FCREATORID BIGINT DEFAULT 0 NOT NULL,
	FMODIFIERID BIGINT DEFAULT 0 NOT NULL,
	FENABLE VARCHAR(50) DEFAULT ' ' NOT NULL,
	FCREATETIME DATETIME,
	FMODIFYTIME DATETIME,
	FMASTERID BIGINT DEFAULT 0 NOT NULL,
	FGROUPID BIGINT DEFAULT 0 NOT NULL,
	FORGID BIGINT DEFAULT 0 NOT NULL,
	FCREATEORGID BIGINT DEFAULT 0 NOT NULL,
	FCTRLSTRATEGY VARCHAR(50) DEFAULT ' ' NOT NULL,
	FSOURCEDATAID BIGINT DEFAULT 0 NOT NULL,
	FBITINDEX BIGINT DEFAULT 0 NOT NULL,
	FSOURCEBITINDEX BIGINT DEFAULT 0 NOT NULL,
	FSERIESID BIGINT DEFAULT 0 NOT NULL,
    FTYPE VARCHAR(30) DEFAULT ' ' NOT NULL,
	FMATERIALID BIGINT DEFAULT 0 NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_INTENSIVE_L')
CREATE TABLE T_MPS_INTENSIVE_L (
	FPKID VARCHAR(36) DEFAULT ' ' NOT NULL,
	FID BIGINT DEFAULT 0 NOT NULL,
	FLOCALEID VARCHAR(10) DEFAULT ' ' NOT NULL,
	FNAME VARCHAR(50) DEFAULT ' ' NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_INTENSIVEENTRY')
CREATE TABLE T_MPS_INTENSIVEENTRY (
	FID BIGINT DEFAULT 0 NOT NULL,
	FENTRYID BIGINT DEFAULT 0 NOT NULL,
	FSEQ INT DEFAULT 0 NOT NULL,
	FFEATUREID BIGINT DEFAULT 0 NOT NULL,
	FENTRYVALUE VARCHAR(100) DEFAULT ' ' NOT NULL,
	FENTRYVALUEID VARCHAR(100) DEFAULT ' ' NOT NULL,
	FENTRYVALUENAME VARCHAR(100) DEFAULT ' ' NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_MUTEXRULES')
CREATE TABLE T_MPS_MUTEXRULES (
	FID BIGINT DEFAULT 0 NOT NULL,
	FNUMBER VARCHAR(30) DEFAULT ' ' NOT NULL,
	FNAME VARCHAR(50) DEFAULT ' ' NOT NULL,
	FSTATUS VARCHAR(50) DEFAULT ' ' NOT NULL,
	FCREATORID BIGINT DEFAULT 0 NOT NULL,
	FMODIFIERID BIGINT DEFAULT 0 NOT NULL,
	FENABLE VARCHAR(50) DEFAULT ' ' NOT NULL,
	FCREATETIME DATETIME,
	FMODIFYTIME DATETIME,
	FMASTERID BIGINT DEFAULT 0 NOT NULL,
	FCREATEORGID BIGINT DEFAULT 0 NOT NULL,
	FORGID BIGINT DEFAULT 0 NOT NULL,
	FCTRLSTRATEGY VARCHAR(50) DEFAULT ' ' NOT NULL,
	FSOURCEDATAID BIGINT DEFAULT 0 NOT NULL,
	FBITINDEX BIGINT DEFAULT 0 NOT NULL,
	FSOURCEBITINDEX BIGINT DEFAULT 0 NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_MUTEXRULES_L')
CREATE TABLE T_MPS_MUTEXRULES_L (
	FPKID VARCHAR(36) DEFAULT ' ' NOT NULL,
	FID BIGINT DEFAULT 0 NOT NULL,
	FLOCALEID VARCHAR(10) DEFAULT ' ' NOT NULL,
	FNAME VARCHAR(50) DEFAULT ' ' NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_MUTEXRULESENTRY')
CREATE TABLE T_MPS_MUTEXRULESENTRY (
	FID BIGINT DEFAULT 0 NOT NULL,
	FENTRYID BIGINT DEFAULT 0 NOT NULL,
	FSEQ INT DEFAULT 0 NOT NULL,
	FTYPE VARCHAR(50) DEFAULT ' ' NOT NULL,
	FTIMEPERIOD VARCHAR(50) DEFAULT ' ' NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_MUTEXRULESGROUP')
CREATE TABLE T_MPS_MUTEXRULESGROUP (
	FPKID BIGINT DEFAULT 0 NOT NULL,
	FENTRYID BIGINT DEFAULT 0 NOT NULL,
	FBASEDATAID BIGINT DEFAULT 0 NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_MUTEXRULESRANGE')
CREATE TABLE T_MPS_MUTEXRULESRANGE (
	FPKID BIGINT DEFAULT 0 NOT NULL,
	FENTRYID BIGINT DEFAULT 0 NOT NULL,
	FBASEDATAID BIGINT DEFAULT 0 NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_PROCHANGERULES')
CREATE TABLE T_MPS_PROCHANGERULES (
	FID BIGINT DEFAULT 0 NOT NULL,
	FNUMBER VARCHAR(30) DEFAULT ' ' NOT NULL,
	FNAME VARCHAR(50) DEFAULT ' ' NOT NULL,
	FSTATUS VARCHAR(50) DEFAULT ' ' NOT NULL,
	FCREATORID BIGINT DEFAULT 0 NOT NULL,
	FMODIFIERID BIGINT DEFAULT 0 NOT NULL,
	FENABLE VARCHAR(50) DEFAULT ' ' NOT NULL,
	FCREATETIME DATETIME,
	FMODIFYTIME DATETIME,
	FMASTERID BIGINT DEFAULT 0 NOT NULL,
	FCREATEORGID BIGINT DEFAULT 0 NOT NULL,
	FORGID BIGINT DEFAULT 0 NOT NULL,
	FCTRLSTRATEGY VARCHAR(50) DEFAULT ' ' NOT NULL,
	FSOURCEDATAID BIGINT DEFAULT 0 NOT NULL,
	FBITINDEX BIGINT DEFAULT 0 NOT NULL,
	FSOURCEBITINDEX BIGINT DEFAULT 0 NOT NULL,
	FWORKCENTERID BIGINT DEFAULT 0 NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_PROCHANGERULES_L')
CREATE TABLE T_MPS_PROCHANGERULES_L (
	FPKID VARCHAR(36) DEFAULT ' ' NOT NULL,
	FID BIGINT DEFAULT 0 NOT NULL,
	FLOCALEID VARCHAR(10) DEFAULT ' ' NOT NULL,
	FNAME VARCHAR(50) DEFAULT ' ' NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_PROCHANGERULESENTRY')
CREATE TABLE T_MPS_PROCHANGERULESENTRY (
	FID BIGINT DEFAULT 0 NOT NULL,
	FENTRYID BIGINT DEFAULT 0 NOT NULL,
	FSEQ INT DEFAULT 0 NOT NULL,
	FAFTERGROUPID BIGINT DEFAULT 0 NOT NULL,
	FQTY DECIMAL(23,10) DEFAULT 0 NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_PROCHANGERULESSUB')
CREATE TABLE T_MPS_PROCHANGERULESSUB (
	FPKID BIGINT DEFAULT 0 NOT NULL,
	FENTRYID BIGINT DEFAULT 0 NOT NULL,
	FBASEDATAID BIGINT DEFAULT 0 NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_PRODUCTIONRULES')
CREATE TABLE T_MPS_PRODUCTIONRULES (
	FID BIGINT DEFAULT 0 NOT NULL,
	FNUMBER VARCHAR(30) DEFAULT ' ' NOT NULL,
	FNAME VARCHAR(50) DEFAULT ' ' NOT NULL,
	FSTATUS VARCHAR(50) DEFAULT ' ' NOT NULL,
	FCREATORID BIGINT DEFAULT 0 NOT NULL,
	FMODIFIERID BIGINT DEFAULT 0 NOT NULL,
	FENABLE VARCHAR(50) DEFAULT ' ' NOT NULL,
	FCREATETIME DATETIME,
	FMODIFYTIME DATETIME,
	FMASTERID BIGINT DEFAULT 0 NOT NULL,
	FCREATEORGID BIGINT DEFAULT 0 NOT NULL,
	FORGID BIGINT DEFAULT 0 NOT NULL,
	FCTRLSTRATEGY VARCHAR(50) DEFAULT ' ' NOT NULL,
	FSOURCEDATAID BIGINT DEFAULT 0 NOT NULL,
	FBITINDEX BIGINT DEFAULT 0 NOT NULL,
	FSOURCEBITINDEX BIGINT DEFAULT 0 NOT NULL,
	FWORKCENTERID BIGINT DEFAULT 0 NOT NULL,
	FPRODUCTIONTYPE VARCHAR(50) DEFAULT ' ' NOT NULL,
	FCAPACITYDEFINITIONID BIGINT DEFAULT 0 NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_PRODUCTIONRULES_L')
CREATE TABLE T_MPS_PRODUCTIONRULES_L (
	FPKID VARCHAR(36) DEFAULT ' ' NOT NULL,
	FID BIGINT DEFAULT 0 NOT NULL,
	FLOCALEID VARCHAR(10) DEFAULT ' ' NOT NULL,
	FNAME VARCHAR(50) DEFAULT ' ' NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_PRODUCTIONRULESE')
CREATE TABLE T_MPS_PRODUCTIONRULESE (
	FID BIGINT DEFAULT 0 NOT NULL,
	FENTRYID BIGINT DEFAULT 0 NOT NULL,
	FSEQ INT DEFAULT 0 NOT NULL,
	FGROUP BIGINT DEFAULT 0 NOT NULL,
	FRATIO BIGINT DEFAULT 0 NOT NULL,
	FQTY BIGINT DEFAULT 0 NOT NULL,
	FTYPE VARCHAR(50) DEFAULT ' ' NOT NULL,
	FMAX BIGINT DEFAULT 0 NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_PRODUCTIONRULESR')
CREATE TABLE T_MPS_PRODUCTIONRULESR (
	FID BIGINT DEFAULT 0 NOT NULL,
	FENTRYID BIGINT DEFAULT 0 NOT NULL,
	FSEQ INT DEFAULT 0 NOT NULL,
	FPRIORITY BIGINT DEFAULT 0 NOT NULL,
	FGROUP BIGINT DEFAULT 0 NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MPS_PRODUCTIONRULESS')
CREATE TABLE T_MPS_PRODUCTIONRULESS (
	FENTRYID BIGINT DEFAULT 0 NOT NULL,
	FDETAILID BIGINT DEFAULT 0 NOT NULL,
	FSEQ INT DEFAULT 0 NOT NULL,
	FGROUP BIGINT DEFAULT 0 NOT NULL,
	FCONSTRAINTTYPE VARCHAR(50) DEFAULT ' ' NOT NULL,
	FRATIO BIGINT DEFAULT 0 NOT NULL,
	FQTY BIGINT DEFAULT 0 NOT NULL,
	FCOMBOFIELD VARCHAR(50) DEFAULT ' ' NOT NULL,
	FMAX BIGINT DEFAULT 0 NOT NULL,
	FPARENTGROUPID BIGINT DEFAULT 0 NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_MRP_INTGROUP')
CREATE TABLE T_MRP_INTGROUP (
	FID BIGINT DEFAULT 0 NOT NULL,
	FNUMBER VARCHAR(30) DEFAULT ' ' NOT NULL,
	FNAME VARCHAR(50) DEFAULT ' ' NOT NULL,
	FSTATUS VARCHAR(50) DEFAULT ' ' NOT NULL,
	FCREATORID BIGINT DEFAULT 0 NOT NULL,
	FMODIFIERID BIGINT DEFAULT 0 NOT NULL,
	FENABLE VARCHAR(50) DEFAULT ' ' NOT NULL,
	FCREATETIME DATETIME,
	FMODIFYTIME DATETIME,
	FMASTERID BIGINT DEFAULT 0 NOT NULL,
	FLONGNUMBER VARCHAR(50) DEFAULT ' ' NOT NULL,
	FLEVEL BIGINT DEFAULT 0 NOT NULL,
	FISLEAF CHAR(1) DEFAULT '1' NOT NULL,
	FPARENTID BIGINT DEFAULT 0 NOT NULL
);
