
IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PMPD_RESOURCEPLAN')
CREATE TABLE T_PMPD_RESOURCEPLAN (
		FID                         BIGINT                 DEFAULT 0          NOT NULL,              
		FBILLNO                     NVARCHAR(30)           DEFAULT ' '        NOT NULL,     
		FBILLSTATUS                 NVARCHAR(50)           DEFAULT ' '        NOT NULL,      
		FCREATORID                  BIGINT                 DEFAULT 0          NOT NULL,              
		FMODIFIERID                 BIGINT                 DEFAULT 0          NOT NULL,             
		FAUDITORID                  BIGINT                 DEFAULT 0          NOT NULL,              
		FAUDITDATE                  DATETIME,                              
		FMODIFYTIME                 DATETIME,                              
		FCREATETIME                 DATETIME,                               
		FORGID                      BIGINT                 DEFAULT 0          NOT NULL,             
		FBILLTYPE                   BIGINT                 DEFAULT 0          NOT NULL,              
		FCUSTOMERID                 BIGINT                 DEFAULT 0          NOT NULL,              
		FDEMANDDATE                 DATETIME,                              
		FDEMANDDEPTID               BIGINT                 DEFAULT 0          NOT NULL,             
		FAPPLYER                    BIGINT                 DEFAULT 0          NOT NULL,             
		FPROJECTORGID               BIGINT                 DEFAULT 0          NOT NULL,              
		FOVERDEVICEID               BIGINT                 DEFAULT 0          NOT NULL,            
		FSOURCEBILLTYPE             NVARCHAR(50)           DEFAULT ' '        NOT NULL,      
		FSOURCEBILLNO               NVARCHAR(50)           DEFAULT ' '        NOT NULL,      
		FESTIAPPROACHTIME           DATETIME,                               
		FESTIDEPARTTIME             DATETIME,                               
		FCONSTRUCTIONUNITID         BIGINT                 DEFAULT 0          NOT NULL,              
		FREPAIRCYCLE                DECIMAL(23,10)         DEFAULT 0          NOT NULL,                  
		FREALAPPROACHTIME           DATETIME,                              
		FREALDEPARTTIME             DATETIME,                               
		FREALREPAIRCYCLE            DECIMAL(23,10)         DEFAULT 0          NOT NULL,                     
		FPREAPPROACHTIME            DATETIME,                             
		FPREDEPARTTIME              DATETIME,                               
		FWORKREPAIRCYCLE            DECIMAL(23,10)         DEFAULT 0          NOT NULL,     
		FWORKCENTERID               BIGINT                 DEFAULT 0          NOT NULL,              
		FUNITLENGTH                 INT                    DEFAULT 0          NOT NULL,                
		FRESOURCEPLANSTATUSID       BIGINT                 DEFAULT 0          NOT NULL,              
		FSOURCEBILLENTRYSEQ         NVARCHAR(50)           DEFAULT ' '        NOT NULL,      
		FISPUSH                     CHAR(1)                DEFAULT '0'        NOT NULL,           
		FREPAIRCYCLEDAY             DECIMAL(23,10)         DEFAULT 0          NOT NULL
);


IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PMPD_RESPLAN_CONTRACT')
CREATE TABLE T_PMPD_RESPLAN_CONTRACT (
	FID                             BIGINT                  DEFAULT 0         NOT NULL,              
	FENTRYID                        BIGINT                  DEFAULT 0         NOT NULL,            
	FSEQ                            INT                     DEFAULT 0         NOT NULL,                 
	FCONTRACTID                     BIGINT                  DEFAULT 0         NOT NULL,              
	FCONTRACTNO                     NVARCHAR(50)            DEFAULT ' '       NOT NULL,      
	FCONTRACTNAME                   NVARCHAR(50)            DEFAULT ' '       NOT NULL
);


IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PMPD_RESPLAN_CONTRACT_L')
CREATE TABLE T_PMPD_RESPLAN_CONTRACT_L (
	FPKID                           NVARCHAR(36)            DEFAULT ' '       NOT NULL,      
	FENTRYID                        BIGINT                  DEFAULT 0         NOT NULL,             
	FLOCALEID                       NVARCHAR(10)            DEFAULT ' '       NOT NULL,     
	FCONTRACTNAME                   NVARCHAR(50)            DEFAULT ' '       NOT NULL
);


IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PMPD_RESPLAN_PROJECT')
CREATE TABLE T_PMPD_RESPLAN_PROJECT (
	FID                             BIGINT                  DEFAULT 0         NOT NULL,              
	FENTRYID                        BIGINT                  DEFAULT 0         NOT NULL,           
	FSEQ                            INT                     DEFAULT 0         NOT NULL,                
	FPROJCETID                      BIGINT                  DEFAULT 0         NOT NULL
);


IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PMPD_RESPLAN_SITETIME')
CREATE TABLE T_PMPD_RESPLAN_SITETIME (
	FID                             BIGINT                  DEFAULT 0         NOT NULL,             
	FENTRYID                        BIGINT                  DEFAULT 0         NOT NULL,             
	FSEQ                            INT                     DEFAULT 0         NOT NULL,                
	FSECTIONRESOURCEID              BIGINT                  DEFAULT 0         NOT NULL,              
	FSECTIONSTARTTIME               DATETIME,                             
	FSECTIONENDTIME                 DATETIME,                               
	FREALSTARTTIME                  DATETIME,                              
	FREALENDTIME                    DATETIME                        
);





