IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PMPD_APPROACHAPPLY')
CREATE TABLE T_PMPD_APPROACHAPPLY (
	FID                         BIGINT                 DEFAULT 0        NOT NULL,              
	FBILLNO                     NVARCHAR(30)           DEFAULT ' '      NOT NULL,      
	FBILLSTATUS                 NVARCHAR(50)           DEFAULT ' '      NOT NULL,     
	FCREATORID                  BIGINT                 DEFAULT 0        NOT NULL,            
	FMODIFIERID                 BIGINT                 DEFAULT 0        NOT NULL,              
	FAUDITORID                  BIGINT                 DEFAULT 0        NOT NULL,             
	FAUDITDATE                  DATETIME,                               
	FMODIFYTIME                 DATETIME,                               
	FCREATETIME                 DATETIME,                               
	FORGID                      BIGINT                 DEFAULT 0        NOT NULL,              
	FBILLTYPE                   BIGINT                 DEFAULT 0        NOT NULL,              
	FCUSTOMERID                 BIGINT                 DEFAULT 0        NOT NULL,              
    FAPPLYDATE                  DATETIME,                               
    FAPPLYDEPTID                BIGINT                 DEFAULT 0        NOT NULL,              
    FAPPLICANTID                BIGINT                 DEFAULT 0        NOT NULL,              
    FAPPLYORGID                 BIGINT                 DEFAULT 0        NOT NULL,             
    FREMARK                     NVARCHAR(255)          DEFAULT ' '      NOT NULL
);


IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PMPD_APPROACHAPPLY_L')
CREATE TABLE T_PMPD_APPROACHAPPLY_L (
	FPKID                       NVARCHAR(36)          DEFAULT ' '         NOT NULL,     
	FLOCALEID                   NVARCHAR(10)          DEFAULT ' '         NOT NULL,
    FREMARK                     NVARCHAR(255)         DEFAULT ' '         NOT NULL
);



IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PMPD_APPROACHENTRY')
CREATE TABLE T_PMPD_APPROACHENTRY (
	FID                         BIGINT                DEFAULT 0          NOT NULL,             
	FENTRYID                    BIGINT                DEFAULT 0          NOT NULL,            
	FSEQ                        INT                   DEFAULT 0          NOT NULL,                
    FEQUIPMENTID                BIGINT                DEFAULT 0          NOT NULL,            
    FWORKCENTERID               BIGINT                DEFAULT 0          NOT NULL,             
    FSTARTTIME                  DATETIME,                               
    FENDTIME                    DATETIME,                             
    FDURATIONUNITID             BIGINT                DEFAULT 0          NOT NULL,             
    FUNITLENGTH                 INT                   DEFAULT 0          NOT NULL,               
    FDURATION                   DECIMAL(23,10)        DEFAULT 0          NOT NULL,     
    FSOURCEBILLNO               NVARCHAR(50)          DEFAULT ' '        NOT NULL,     
    FSOURCEBILLTYPE             NVARCHAR(50)          DEFAULT ' '        NOT NULL,     
    FRESOURCEPLANNO             NVARCHAR(50)          DEFAULT ' '        NOT NULL,     
    FASSIGNEDWORKCENTERID       BIGINT                DEFAULT 0          NOT NULL,              
    FISAPPLYSEGMENT             CHAR(1)               DEFAULT '0'        NOT NULL
);


IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PMPD_APPROACHSPLIT')
CREATE TABLE T_PMPD_APPROACHSPLIT (
    FENTRYID                    BIGINT                DEFAULT 0          NOT NULL,            
    FDETAILID                   BIGINT                DEFAULT 0          NOT NULL,        
	FSEQ                        INT                   DEFAULT 0          NOT NULL,               
    FWORKCENTERID               BIGINT                DEFAULT 0          NOT NULL,           
    FSTARTTIME                  DATETIME,                          
    FENDTIME                    DATETIME
);


