IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PMPD_TEMPLATE_REPORT')
CREATE TABLE T_PMPD_TEMPLATE_REPORT (
	FID                         BIGINT            DEFAULT 0     NOT NULL,             
    FBILLNO                     NVARCHAR(30)      DEFAULT ' '   NOT NULL,    
    FBILLSTATUS                 NVARCHAR(50)      DEFAULT ' '   NOT NULL,     
    FCREATORID                  BIGINT            DEFAULT 0     NOT NULL,            
    FMODIFIERID                 BIGINT            DEFAULT 0     NOT NULL,            
    FAUDITORID                  BIGINT            DEFAULT 0     NOT NULL,             
    FCREATETIME                 DATETIME,                              
    FMODIFYTIME                 DATETIME,                             
    FAUDITDATE                  DATETIME,                               
    FORGID                      BIGINT            DEFAULT 0     NOT NULL,             
    FESTIMATEWORKHOURID         BIGINT            DEFAULT 0     NOT NULL,             
    FSTAGEWORKHOURID            BIGINT            DEFAULT 0     NOT NULL,          
    FREASON                     NVARCHAR(50)      DEFAULT ' '   NOT NULL,     
    FDATE                       DATETIME,                            
    FOPERATORID                 BIGINT            DEFAULT 0     NOT NULL
);


IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PMPD_REPORT_PLANENTRY')
CREATE TABLE T_PMPD_REPORT_PLANENTRY (
    FENTRYID                    BIGINT            DEFAULT 0     NOT NULL,             
    FID                         BIGINT            DEFAULT 0     NOT NULL,             
	FSEQ                        INT               DEFAULT 0     NOT NULL,                 
    FRESOURCEPLAN               NVARCHAR(80)      DEFAULT ' '   NOT NULL,    
    FPREESTIMATEDBILL           NVARCHAR(50)      DEFAULT ' '   NOT NULL,     
    FCURESTIMATEDBILL           NVARCHAR(50)      DEFAULT ' '   NOT NULL,     
    FISSYNC                     CHAR(1)           DEFAULT '0'   NOT NULL,           
    FRESOURCEPLANID             BIGINT            DEFAULT 0     NOT NULL,              
    FPREESTIMATEDBILLID         BIGINT            DEFAULT 0     NOT NULL,              
    FCURESTIMATEDBILLID         BIGINT            DEFAULT 0     NOT NULL
);


IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PMPD_REPORT_ESTIENTRY')
CREATE TABLE T_PMPD_REPORT_ESTIENTRY (
    FENTRYID                    BIGINT            DEFAULT 0     NOT NULL,             
    FID                         BIGINT            DEFAULT 0     NOT NULL,             
	FSEQ                        INT               DEFAULT 0     NOT NULL,                
    FINDUSTRYID                 BIGINT            DEFAULT 0     NOT NULL,              
    FPREROUTINEWORKHOUR         DECIMAL(23,10)    DEFAULT 0     NOT NULL,      
    FCURROUTINEWORKHOUR         DECIMAL(23,10)    DEFAULT 0     NOT NULL,      
    FPRENONROUTINEWORKHOUR      DECIMAL(23,10)    DEFAULT 0     NOT NULL,      
    FCURNONROUTINEWORKHOUR      DECIMAL(23,10)    DEFAULT 0     NOT NULL,      
    FPRETOTALHOURS              DECIMAL(23,10)    DEFAULT 0     NOT NULL,      
    FCURTOTALHOURS              DECIMAL(23,10)    DEFAULT 0     NOT NULL
);


IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PMPD_REPORT_STAGEENTRY')
CREATE TABLE T_PMPD_REPORT_STAGEENTRY (
    FDETAILID                   BIGINT            DEFAULT 0     NOT NULL,              
    FENTRYID                    BIGINT            DEFAULT 0     NOT NULL,              
	FSEQ                        INT               DEFAULT 0     NOT NULL,                
    FSTAGE                      INT               DEFAULT 0     NOT NULL,               
    FPREPERCENTAGE              DECIMAL(23,10)    DEFAULT 0     NOT NULL,     
    FCURPERCENTAGE              DECIMAL(23,10)    DEFAULT 0     NOT NULL
);
