﻿
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PMPD_RESOURCEPLAN' AND KSQL_COL_NAME ='FDIF')
 ALTER TABLE T_PMPD_RESOURCEPLAN ADD ( FDIF  NVARCHAR(255) DEFAULT ' ' NOT NULL );
 
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PMPD_RESOURCEPLAN' AND KSQL_COL_NAME ='FCHANGEENTITY')
 ALTER TABLE T_PMPD_RESOURCEPLAN ADD ( FCHANGEENTITY NVARCHAR(255) DEFAULT ' ' NOT NULL );
 
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PMPD_RESPLAN_SITETIME' AND KSQL_COL_NAME ='FDIF')
 ALTER TABLE T_PMPD_RESPLAN_SITETIME ADD ( FDIF NVARCHAR(50) DEFAULT ' ' NOT NULL );
 
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PMPD_RESPL_MILESTONE' AND KSQL_COL_NAME ='FDIF')
 ALTER TABLE T_PMPD_RESPL_MILESTONE ADD ( FDIF NVARCHAR(255) DEFAULT ' ' NOT NULL );
 
 
IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PMPD_PRERESETTING') 
 CREATE TABLE T_PMPD_PRERESETTING (
	  FID                BIGINT              DEFAULT 0     NOT NULL,         
	  FNUMBER            NVARCHAR(30)        DEFAULT ' '   NOT NULL, 	
	  FCREATEORGID       BIGINT              DEFAULT 0     NOT NULL, 	
	  FORGID             BIGINT              DEFAULT 0     NOT NULL,       	
	  FCTRLSTRATEGY      NVARCHAR(5)         DEFAULT ' '   NOT NULL, 	
	  FSOURCEDATAID      BIGINT              DEFAULT 0     NOT NULL, 	
	  FBITINDEX          INT                 DEFAULT 0     NOT NULL,     
	  FSOURCEBITINDEX    INT                 DEFAULT 0     NOT NULL, 	
	  FAUDITORID         BIGINT              DEFAULT 0     NOT NULL,   	
	  FAUDITTIME         DATETIME ,                   
	  FSTATUS            NVARCHAR(1)         DEFAULT ' '   NOT NULL, 
	  FCREATORID         BIGINT              DEFAULT 0     NOT NULL,   
	  FMODIFIERID        BIGINT              DEFAULT 0     NOT NULL,  	
	  FENABLE            NVARCHAR(1)         DEFAULT ' '   NOT NULL, 
	  FCREATETIME        DATETIME ,                 
	  FMODIFYTIME        DATETIME ,                  
	  FMASTERID          BIGINT              DEFAULT 0     NOT NULL,    	
	  FNAME              NVARCHAR(50)        DEFAULT ' '   NOT NULL 
);

EXEC P_ALTERPK 'PK_PMPD_PRERESETTING', 'T_PMPD_PRERESETTING', 'FID', '1';

IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_PMPD_PRERESETTING_FNUM') CREATE INDEX IDX_PMPD_PRERESETTING_FNUM ON T_PMPD_PRERESETTING (FNUMBER);

IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_PMPD_PRERESETTING_FCT') CREATE INDEX IDX_PMPD_PRERESETTING_FCT ON T_PMPD_PRERESETTING (FCREATETIME);


IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PMPD_PRERESETTING_L') 
 CREATE TABLE T_PMPD_PRERESETTING_L (
	  FPKID              NVARCHAR(255)        DEFAULT ' '   NOT NULL,          
	  FID                BIGINT               DEFAULT 0     NOT NULL,         
	  FLOCALEID          NVARCHAR(255)        DEFAULT ' '   NOT NULL,          
	  FNAME              NVARCHAR(50)         DEFAULT ' '   NOT NULL
);

EXEC P_ALTERPK 'PK_PMPD_PRERESETTING_L', 'T_PMPD_PRERESETTING_L', 'FPKID', '1';

IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_PMPD_PRERESETTING_L_FID') CREATE INDEX IDX_PMPD_PRERESETTING_L_FID ON T_PMPD_PRERESETTING_L (FID,FLOCALEID);

IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_PMPD_PRERESETTING_FCT') CREATE INDEX IDX_PMPD_PRERESETTING_FCT ON T_PMPD_PRERESETTING_L (FNAME);
 
 
IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PMPD_PRERESETENTRY') 
 CREATE TABLE T_PMPD_PRERESETENTRY (
	  FID           BIGINT           DEFAULT 0      NOT NULL,         
	  FENTRYID      BIGINT           DEFAULT 0      NOT NULL,     
	  FSEQ          INT              DEFAULT 0      NOT NULL,            	
	  FFIELD        NVARCHAR(255)    DEFAULT ' '    NOT NULL, 	
	  FFIELDNAME    NVARCHAR(255)    DEFAULT ' '    NOT NULL, 	
	  FENTITY       NVARCHAR(255)    DEFAULT ' '    NOT NULL, 	
	  FENTITYNAME   NVARCHAR(255)    DEFAULT ' '    NOT NULL, 	
	  FISRELEASE    CHAR(1)          DEFAULT '0'    NOT NULL
);

EXEC P_ALTERPK 'PK_PMPD_PRERESETENTRY', 'T_PMPD_PRERESETENTRY', 'FENTRYID', '1';
 
IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_PMPD_PRERESETENTRY_FSEQ') CREATE INDEX IDX_PMPD_PRERESETENTRY_FSEQ ON T_PMPD_PRERESETENTRY (FID,FSEQ);


IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PMPD_RESOURCEPLAN_A' AND KSQL_COL_NAME ='FENGINEMODELID')
 ALTER TABLE T_PMPD_RESOURCEPLAN_A ADD ( FENGINEMODELID  BIGINT DEFAULT 0 NOT NULL );
 
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PMPD_APPROACHENTRY' AND KSQL_COL_NAME ='FENGINEMODELID')
 ALTER TABLE T_PMPD_APPROACHENTRY ADD ( FENGINEMODELID  BIGINT DEFAULT 0 NOT NULL );




 


 








