IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_SFC_SHIFTHO')
CREATE TABLE T_SFC_SHIFTHO (
FID BIGINT DEFAULT 0 NOT NULL,
FBILLNO NVARCHAR(30) DEFAULT ' ' NOT NULL,
FBILLSTATUS NVARCHAR(50) DEFAULT ' ' NOT NULL,
FCREATORID BIGINT DEFAULT 0 NOT NULL,
FMODIFIERID BIGINT DEFAULT 0 NOT NULL,
FAUDITORID BIGINT DEFAULT 0 NOT NULL,
FAUDITDATE DATETIME,
FMODIFYTIME DATETIME,
FCREATETIME DATETIME,
FORGID BIGINT DEFAULT 0 NOT NULL,
FHANDOVERPERSONID BIGINT DEFAULT 0 NOT NULL,
FHOPERSMOBILE NVARCHAR(50) DEFAULT ' ' NOT NULL,
FHANDOVERTIME DATETIME,
FHANDOVERSTATUS NVARCHAR(30) DEFAULT ' ' NOT NULL,
FRECEIVEDBYID BIGINT DEFAULT 0 NOT NULL,
FINDUSTRYID BIGINT DEFAULT 0 NOT NULL,
FPERSCOUNT BIGINT DEFAULT 1 NOT NULL,
FISCONTENTRYUPD CHAR(1) DEFAULT ' ' NOT NULL,
FISSPNTCENTRYUPD CHAR(1) DEFAULT ' ' NOT NULL
);

EXEC P_ALTERPK 'PK_T_SFC_SHIFTHO', 'T_SFC_SHIFTHO', 'FID', '1';

IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_T_SFC_SHIFTHO') CREATE INDEX IDX_T_SFC_SHIFTHO ON T_SFC_SHIFTHO ( FBILLNO ,FCREATORID );

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_SFC_SHIFTHO_CONTENTRY')
CREATE TABLE T_SFC_SHIFTHO_CONTENTRY (
FID BIGINT DEFAULT 0 NOT NULL,
FENTRYID BIGINT DEFAULT 0 NOT NULL,
FSEQ INT DEFAULT 0 NOT NULL,
FCONTENT NVARCHAR(255) DEFAULT ' ' NOT NULL,
FNOTICE NVARCHAR(255) DEFAULT ' ' NOT NULL,
FDAILYPLANID BIGINT DEFAULT 0 NOT NULL,
FTASKNO NVARCHAR(50) DEFAULT ' ' NOT NULL,
FTASKSTATUS NVARCHAR(50) DEFAULT ' ' NOT NULL,
FOVHLORDENTRYID BIGINT DEFAULT 0 NOT NULL,
FISCARD CHAR(1) DEFAULT ' ' NOT NULL,
FISSIGN CHAR(1) DEFAULT ' ' NOT NULL,
FISENGRCK CHAR(1) DEFAULT ' ' NOT NULL,
FISWORKLOG CHAR(1) DEFAULT ' ' NOT NULL,
FOTHFDBK NVARCHAR(255) DEFAULT ' ' NOT NULL
);

EXEC P_ALTERPK 'PK_T_SFC_SHIFTHO_CONTENTRY', 'T_SFC_SHIFTHO_CONTENTRY', 'FENTRYID', '1';

IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_T_SFC_SHIFTHO_CONTENTRY') CREATE INDEX IDX_T_SFC_SHIFTHO_CONTENTRY ON T_SFC_SHIFTHO_CONTENTRY ( FID ,FSEQ );

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_SFC_SHIFTHO_CONTENTRY_L')
CREATE TABLE T_SFC_SHIFTHO_CONTENTRY_L (
FPKID BIGINT DEFAULT 0 NOT NULL,
FENTRYID BIGINT DEFAULT 0 NOT NULL,
FLOCALEID NVARCHAR(10) DEFAULT ' ' NOT NULL,
FOTHFDBK NVARCHAR(255) DEFAULT ' ' NOT NULL
);

EXEC P_ALTERPK 'PK_T_SFC_SHIFTHO_CONTENTRY_L', 'T_SFC_SHIFTHO_CONTENTRY_L', 'FPKID', '1';

IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_T_SFC_SHIFTHO_CONTENTRY_L') CREATE INDEX IDX_T_SFC_SHIFTHO_CONTENTRY_L ON T_SFC_SHIFTHO_CONTENTRY_L ( FENTRYID ,FLOCALEID );

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_SFC_SHIFTHO_PERSENTRY')
CREATE TABLE T_SFC_SHIFTHO_PERSENTRY (
FID BIGINT DEFAULT 0 NOT NULL,
FENTRYID BIGINT DEFAULT 0 NOT NULL,
FSEQ INT DEFAULT 0 NOT NULL,
FPERSONID BIGINT DEFAULT 0 NOT NULL,
FCSID BIGINT DEFAULT 0 NOT NULL,
FSHIFTID BIGINT DEFAULT 0 NOT NULL,
FREMARK NVARCHAR(255) DEFAULT ' ' NOT NULL
);

EXEC P_ALTERPK 'PK_T_SFC_SHIFTHO_PERSENTRY', 'T_SFC_SHIFTHO_PERSENTRY', 'FENTRYID', '1';

IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_T_SFC_SHIFTHO_PERSENTRY') CREATE INDEX IDX_T_SFC_SHIFTHO_PERSENTRY ON T_SFC_SHIFTHO_PERSENTRY ( FID ,FSEQ );

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_SFC_SHIFTHO_PERSENTRY_L')
CREATE TABLE T_SFC_SHIFTHO_PERSENTRY_L (
FPKID BIGINT DEFAULT 0 NOT NULL,
FENTRYID BIGINT DEFAULT 0 NOT NULL,
FLOCALEID NVARCHAR(10) DEFAULT ' ' NOT NULL,
FREMARK NVARCHAR(255) DEFAULT ' ' NOT NULL
);

EXEC P_ALTERPK 'PK_T_SFC_SHIFTHO_PERSENTRY_L', 'T_SFC_SHIFTHO_PERSENTRY_L', 'FPKID', '1';

IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_T_SFC_SHIFTHO_PERSENTRY_L') CREATE INDEX IDX_T_SFC_SHIFTHO_PERSENTRY_L ON T_SFC_SHIFTHO_PERSENTRY_L ( FENTRYID ,FLOCALEID );

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_SFC_SHIFTHO_PROJENTRY')
CREATE TABLE T_SFC_SHIFTHO_PROJENTRY (
FID BIGINT DEFAULT 0 NOT NULL,
FENTRYID BIGINT DEFAULT 0 NOT NULL,
FSEQ INT DEFAULT 0 NOT NULL,
FPROJECTID BIGINT DEFAULT 0 NOT NULL
);

EXEC P_ALTERPK 'PK_T_SFC_SHIFTHO_PROJENTRY', 'T_SFC_SHIFTHO_PROJENTRY', 'FENTRYID', '1';

IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_T_SFC_SHIFTHO_PROJENTRY') CREATE INDEX IDX_T_SFC_SHIFTHO_PROJENTRY ON T_SFC_SHIFTHO_PROJENTRY ( FID ,FSEQ );

IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_SFC_SHIFTHO_SPNTCENTRY')
CREATE TABLE T_SFC_SHIFTHO_SPNTCENTRY (
FID BIGINT DEFAULT 0 NOT NULL,
FENTRYID BIGINT DEFAULT 0 NOT NULL,
FSEQ INT DEFAULT 0 NOT NULL,
FCONTENT NVARCHAR(255) DEFAULT ' ' NOT NULL
);

EXEC P_ALTERPK 'PK_T_SFC_SHIFTHO_SPNTCENTRY', 'T_SFC_SHIFTHO_SPNTCENTRY', 'FENTRYID', '1';

IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_T_SFC_SHIFTHO_SPNTCENTRY') CREATE INDEX IDX_T_SFC_SHIFTHO_SPNTCENTRY ON T_SFC_SHIFTHO_SPNTCENTRY ( FID ,FSEQ );
